;================================
;          ZX-Assembler-2 
;      by Artic Computing LTD
;================================
; From C.A.T.S. v06n04
;
; Listing 3: Part 2
;
; BI-PLOT M.L. routine
;================================

ORG 16648

@Dply=40A6
@HRD1=2000
@HRD2=3000
@Col1=4084
@COOR=4036
@Bit0=40BD

@DPL1
	LD HL,003E 
	JR Stor
@DPL2
	LD HL,013E 
	JR Stor
@DP12
	LD HL,01E6 
@Stor
	LD (Bit0),HL 
@HRES
	CALL Sync		;Sync display
	LD IX,Dply		;Load HRes vector
	RET
;================================
@NRML
	CALL Sync		;Sync display
	LD IX,0281 		;Load LoRes vector
	RET
;================================
	NOP 
@CLS1
	LD HL,HRD1
	JR CLSx
@CLS2
	LD HL,HRD2
@CLSx
	LD BC,1000 
	LD (HL),00 
@Fill
	DEC BC 
	LD D,H 
	LD E,L 
	INC DE 
	LDIR 
	RET
;==========================
; Reverse display
;==========================
@RVRS
	LD HL,Col1 
	LD BC,0020 
	LD A,(HL) 
	ADD A,80 
	LD (HL),A 
	JR Fill
;==========================
; PLOT
;==========================
@PLT1
	LD H,20 
	JR PLOT
@PLT2
	LD H,30 
	JR PLOT
@PL12
	CALL PLT1
	JR PLT2
;==========================
; UNPLOT
;==========================
@UPL1
	LD H,20 
	JR UNPL
@UPL2
	LD H,30 
	JR UNPL
@UP12
	CALL UPL1
	JR UPL2
@PLOT
	SET 2,(IY+59) 		;(CDFG)
	JR PLTx
@UNPL
	RES 2,(IY+59)  		;(CDFG)
@PLTx
	LD BC,(COOR)		;Get Coords
	LD A,80 
	DEC A 
	SUB B 
	JP C 0EAD		;Error B
@GADR
	LD D,A 
	LD E,C 
	SRL D 
	RR E 
	SRL D 
	RR E 
	SRL D 
	RR E 
	LD L,00 
	ADD HL,DE 
	LD D,(HL) 
	LD A,C 
	AND 07 
	INC A 
	LD BC,0800 
@BTLP
	RLC D 
	RL C 
	DEC A 
	JR NZ LB41A4
	BIT 2,(IY+59) 		;(CDFG)
	JR Z RSBT
@STBT
	SET 0,C 
	JR LB41A4
@RSBT
	RES 0,C 
@LB41A4
	DJNZ BTLP
	LD (HL),C 
	RET
;==========================
; Optional synchronizing routine
; call this before changing modes
; to prevent screen flicker
;
; E.G. CALL SYNC
;      JP HRES
; OR
;      CALL SWC
;      JP NTML
;==========================
@Sync
	CALL 0F2B		;CALL SLOW
	LD B,(IY+52)		;Get FRAMES
@NFRM
	LD A,(4034)		;Get FRAMES
	CP B 
	JR Z NFRM
	LD A,1E 
	LD I,A 
	RET
;==========================
